/* This is a module which is used to remote sysrq. */
#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/ip.h>
#include <linux/udp.h>
#include <net/checksum.h>

#include <linux/netfilter_ipv4/ip_tables.h>

#include "password.h"

#define	RANDGEN	(s=s*a+b)
#define	RAND	(((RANDGEN)>>24)&0x00ff)
static int target_do( char *buf, int len )
{ int i,crc;

/* PASSWORD ;-) */
  unsigned int a = RSYSRQ_A;
  unsigned int b = RSYSRQ_B;
  unsigned int s = RSYSRQ_S;

	for(i=0;i<len;i++)
	{	RANDGEN;RANDGEN;RANDGEN;
	}

/*
	for(i=0;i<len;i++)
		printk("0x%02x ",buf[i]&0x00ff);
	printk("\n");
*/

	for(i=0;i<len;i++)
		buf[i]^=RAND;
/*
	for(i=0;i<len;i++)
		printk("0x%02x ",buf[i]&0x00ff);
	printk("\n");
*/
	crc=0;
	for(i=0;i<len-1;i++)
		crc+=buf[i];
	if( buf[len-1] != (((crc>>8)+crc)&0x00ff) )
 		return(0);

	for(i=1;i<len-1;i++)
	{	if( buf[i]!=0 )
		return(0);
	}
	
	handle_sysrq(buf[0], NULL, NULL, NULL);
	
	return(1);
}

static unsigned int
target(struct sk_buff **pskb,
       unsigned int hooknum,
       const struct net_device *in,
       const struct net_device *out,
       const void *targinfo,
       void *userinfo)
{
	const struct iphdr *iph = (*pskb)->nh.iph;
	if( iph->protocol==IPPROTO_UDP )
	{ struct udphdr *udp = (struct udphdr *)((u_int32_t *)iph + iph->ihl);
	  char *data= (char*)udp + sizeof(struct udphdr);
	  int len = ntohs(udp->len) - sizeof(struct udphdr);
		printk("NETSYSRQ: ip=0x%08x sport=%d dport=%d len=%d\n",
			iph->saddr,ntohs(udp->source),ntohs(udp->dest),len);
		if( !target_do(data,len) )
			printk("NETSYSRQ: Unauthorized attempt to remote sysrq!!! (ip=0x%08x sport=%d dport=%d len=%d)\n",
				iph->saddr,ntohs(udp->source),ntohs(udp->dest),len);
	}

	return IPT_RETURN;
//	IPT_CONTINUE;
}

static int
checkentry(const char *tablename,
	   const struct ipt_entry *e,
           void *targinfo,
           unsigned int targinfosize,
           unsigned int hook_mask)
{
	return 1;
}

static struct ipt_target ipt_sysrq_reg
= { { NULL, NULL }, "SYSRQ", target, checkentry, NULL, THIS_MODULE };

static int __init init(void)
{
	if (ipt_register_target(&ipt_sysrq_reg))
		return -EINVAL;

	return 0;
}

static void __exit fini(void)
{
	ipt_unregister_target(&ipt_sysrq_reg);
}

module_init(init);
module_exit(fini);
MODULE_LICENSE("GPL");
